#!/usr/bin/perl
### make sure that the FIRST line of this script contains 
### the path to the Perl5 interpreter on your system

###
### Configuration Variables
###

$wordcount = 0;
$title = FALSE;
$author = FALSE;
$url_pat = "http://";
# lines shorter than this many characters will get a <br> added
$short_line = 45;
# put your keywords into the next variable ($keys) if desired
$keys = "";
# edit this variable to insert your ezine's name if desired
$pub = "My Own Ezine";
# edit the publication date here
$pub_date = "January 17";
# edit this variable for table width in % or pixels if you wish
$width = "60%";

###
### Main body of script
###

# capture name of input file, for later use

$file_name = $ARGV[0];
# $pub_date = $ARGV[1]; 

open (FH,">outfile");

# insert HTML header for the page
# replace the HEX values for bgcolor, text, link, vlink if you want different colors
print FH ("<HTML>\n");
print FH ("<HEAD>\n");
print FH ("<META http\-equiv=\"Content-Type\" content=\"text/html; charset=IS0\-8859\-1\">\n");

while ($line = <>) {
    if ($title eq FALSE){
	if ($line !~ /\S/){
	    next;
	}
	$line =~ s/^[ \t]+//;
	$line =~ s/[ \t]+\n$/\n/;
	chop $line;
	print FH ("<TITLE>$line<\/TITLE><br><br>\n");
	print FH ("<META name=\"description\" CONTENT=\"$line\">\n");
	# comment out this line if you don't want a "keywords" meta-tag:
	print FH ("<META name=\"keywords\" CONTENT=\"$keys\">\n");
	print FH ("</HEAD>\n");
        # insert a line to load your page background if desired
	print FH ("<BODY bgcolor=\"#FFFFEE\" text=\"#000000\" link=\"#0000FF\" vlink=\"#990099\">\n");
	print FH ("<p><div align=\"center\"><H2>$line<\/H2>\n");
        $title = TRUE;
        next;
    }
    if ($author eq FALSE){
	if ($line !~ /\S/){
	    next;
	}
	$line =~ s/^[ \t]+//;
	$line =~ s/[ \t]+\n$/\n/;
        chop $line;
	print FH ("<H2>$line<\/H2><\/p>\n");
        # comment out or remove this line if you wish:
	print FH ("<p><H4>{Published on $pub_date via $pub}</H4></p><\/div>\n");
	print FH ("<div align=\"center\"><table width=\"$width\"><tr><td>\n");
	$author = TRUE;
        next;
    }

# capture blank lines and add a paragraph tag
    if ($line !~ /\S/){
        $line = "<p>\n";
	print FH ($line);
	next;
    }

# remove leading whitespace from non-blank lines
     $line =~ s/^[ \t]+//;
     $line =~ s/[ \t]+\n$/\n/;

# convert URLs to clickable links
    if ($line =~ /$url_pat/){
	$string = $line;
	$line = "";
	chop ($string);
        @words = split(/[\t ]+/, $string);
        foreach $word (@words){
	    if ($word =~ /$url_pat/){
		$str1 = "<A HREF=\"$word\">$word</A>";
		$word = $str1;
	    }
	    $line .= $word;
	    $line .= " ";
	}
	if (@words < 3){
	    $line .= "<br>";
	}
    }

# convert email addresses to clickable links
    if ($line =~ /[\da-zA-Z\-\_\.]+\@[\da-zA-Z\-]+\.[\da-zA-Z\-]+/){
	$string = $line;
	$line = "";
	chop ($string);
        @words = split(/[\t ]+/, $string);
        foreach $word (@words){
	    if ($word =~ /\@/){
		$word =~ s/[\S]+://;
		$word=~ s/>//;
		$str1 = "<A HREF=\"mailto:$word\">$word</A>";
		$word = $str1;
	    }
	    $line .= $word;
	    $line .= " ";
	}
    }

# insert <br> after very short lines
    $linesize = length($line);
    if ($linesize < $short_line){
        chop ($line);
	$line .= "<br>";
    }

# insure that the break between two sentences 
# on a line is uniform -> &nbsp;&nbsp;[space]

     $line =~ s/\!\"  (?=[A-Z]|\"[A-Z]|\`)/\!\"\&nbsp\;\&nbsp\; /g;
     $line =~ s/\)\"  (?=[A-Z]|\"[A-Z]|\`)/\)\"\&nbsp\;\&nbsp\; /g;
     $line =~ s/\?\"  (?=[A-Z]|\"[A-Z]|\`)/\?\"\&nbsp\;\&nbsp\; /g;
     $line =~ s/\.\"  (?=[A-Z]|\"[A-Z]|\`)/\.\"\&nbsp\;\&nbsp\; /g;
     $line =~ s/\.  (?=[A-Z]|\"[A-Z]|\`)/\.\&nbsp\;\&nbsp\; /g;
     $line =~ s/\.\n/\.\&nbsp\;\&nbsp\; /g;
     $line =~ s/\. \n/\.\&nbsp\;\&nbsp\; /g;
     $line =~ s/\.  \n/\.\&nbsp\;\&nbsp\; /g;
     $line =~ s/\?  (?=[A-Z]|\"[A-Z]|\`)/\?\&nbsp\;\&nbsp\; /g;
     $line =~ s/\?\n/\?\&nbsp\;\&nbsp\; /g;
     $line =~ s/\? \n/\?\&nbsp\;\&nbsp\; /g;
     $line =~ s/\?  \n/\?\&nbsp\;\&nbsp\; /g;
     $line =~ s/\!  (?=[A-Z]|\"[A-Z]|\`)/\!\&nbsp\;\&nbsp\; /g;
     $line =~ s/\!\n/\!\&nbsp\;\&nbsp\; /g;
     $line =~ s/\! \n/\!\&nbsp\;\&nbsp\; /g;
     $line =~ s/\!  \n/\!\&nbsp\;\&nbsp\; /g;
     $line =~ s/\)  (?=[A-Z]|\"[A-Z]|\`)/\)\&nbsp\;\&nbsp\; /g;
     $line =~ s/\)\n/\)\&nbsp\;\&nbsp\; /g;
     $line =~ s/\) \n/\)\&nbsp\;\&nbsp\; /g;
     $line =~ s/\)  \n/\)\&nbsp\;\&nbsp\; /g;
     $line =~ s/\"\n/\"\&nbsp\;\&nbsp\; /g;
     $line =~ s/\" \n/\"\&nbsp\;\&nbsp\; /g;
     $line =~ s/\"  \n/\"\&nbsp\;\&nbsp\; /g;
     $line =~ s/\n(?=[A-Z]|\"[A-Z])/\n\&nbsp\;\&nbsp\; /g;

# save the current line     
     print FH ("$line\n");

# count words only, ignore separator lines
# remove these lines if word count is not desired
    chop ($line);
    if ($line =~ /\w/){
	@words = split(/[\t ]+/, $line);
	$wordcount += @words;
    }
}

print FH ("</td></tr></table></div>\n");
print FH ("<br>\n");

# end of article body

# print footer for page
# using these lines as an example, replace with your normal page footer
print FH ("<div align=center><table width=500><tr>\n");
print FH ("<td align=center>\n");
print FH ("<a href=\"http://www.roibot.com/r_fsfe.cgi?R637_sigfmei\">\n");
print FH ("<img border=0 src=\"http://www.roibot.com/actionplan/freemoneysig.gif\"></a>\n");
print FH ("</td></tr></table>\n");
print FH ("<div align=\"center\"><br><img src=\"../images/colorbar\.gif\" width=\"600\" height=\"1\" alt=\"colorful line\"><br></div>\n");
print FH ("</BODY>\n");
print FH ("</HTML>\n");

# remove if word count is not desired
print ("Total number of words: $wordcount\n");

# DO NOT EDIT BELOW THIS LINE!
close(FH);

# open "outfile" for reading
unless (open (INFILE,"outfile")) {
    die ("cannot open input file outfile\n");
}

# open $file_name (original source file)
unless (open (OUTFILE,">$file_name")) {
    die ("cannot open output file $file_name\n");
}

# copy "outfile" into original source file
$line = <INFILE>;
while ($line ne "") {
    print OUTFILE ($line);
    $line = <INFILE>;
}


###
### End of main body of script
###

