#!c:\Perl\bin
####!/usr/bin/perl

###
### Configuration Variables
###

$wordcount = 0;
$separator = "*****************************************************************\n";

###
### Main body of script
###

# capture name of input file, for later use

$file_name = $ARGV[0];

open (FH,">outfile");

while ($line = <>) {

# capture blank lines
    if ($line !~ /\S/){
	print FH ($line);
	#print FH ($separator);
	next;
    }

# remove leading whitespace from non-blank lines
     #$line =~ s/^[ ]{14}//; 
     $line =~ s/^[ \t]+//;
     $line =~ s/[ \t]+\n$/\n/;

# ignore lines containing a URL or email address
    if ($line =~ /\@|http:|mailto:|\.com|\.net|\.org/g){
	print FH ($line);
	next;
    }

# insure that the break between two sentences 
# on a line is exactly two spaces

# always capitalize Internet! 
    $line =~ s/internet/Internet/g;
    $line =~ s/website/Web site/g;
    $line =~ s/web/Web/g;
    $line =~ s/But /However, /g;
    $line =~ s/signup/sign up/g;

# for sentences that end with a !"
#    $line =~ s/\!\"(?=[A-Z]|\"[A-Z]|\`)/\!\"  /g;
#    $line =~ s/\!\" (?=[A-Z]|\"[A-Z]|\`)/\!\"  /g;

# for sentences that end with a )"
#    $line =~ s/\)\"(?=[A-Z]|\"[A-Z]|\`)/\)\"  /g;
#    $line =~ s/\)\" (?=[A-Z]|\"[A-Z]|\`)/\)\"  /g;

# for sentences that end with a ?"
#    $line =~ s/\?\"(?=[A-Z]|\"[A-Z]|\`)/\?\"  /g;
#    $line =~ s/\?\" (?=[A-Z]|\"[A-Z]|\`)/\?\"  /g;

# for sentences that end with a ."
#    $line =~ s/\.\"(?=[A-Z]|\"[A-Z]|\`)/\.\"  /g;
#    $line =~ s/\.\" (?=[A-Z]|\"[A-Z]|\`)/\.\"  /g;

# for sentences that end with a .
#    $line =~ s/\.(?=[A-Z]|\"[A-Z]|\`)/\.  /g;
#    $line =~ s/\. (?=[A-Z]|\"[A-Z]|\`)/\.  /g;
#    $line =~ s/\.\.\.  /\.\.\./g;

# for sentences that end with a ?
#    $line =~ s/\?(?=[A-Z]|\"[A-Z]|\`)/\?  /g;
#    $line =~ s/\? (?=[A-Z]|\"[A-Z]|\`)/\?  /g;

# for sentences that end with a !
#    $line =~ s/\!(?=[A-Z]|\"[A-Z]|\`)/\!  /g;
#    $line =~ s/\! (?=[A-Z]|\"[A-Z]|\`)/\!  /g;

# for sentences that end with a )
#    $line =~ s/\)(?=[A-Z]|\"[A-Z]|\`)/\)  /g;
#    $line =~ s/\) (?=[A-Z]|\"[A-Z]|\`)/\)  /g;

# for single-space sentence breaks, use these lines instead:
     $line =~ s/\!\"(?=[A-Z]|\"[A-Z]|\`)/\!\" /g;
     $line =~ s/\)\"(?=[A-Z]|\"[A-Z]|\`)/\)\" /g;
     $line =~ s/\?\"(?=[A-Z]|\"[A-Z]|\`)/\?\" /g;
     $line =~ s/\.\"(?=[A-Z]|\"[A-Z]|\`)/\.\" /g;
     $line =~ s/\.(?=[A-Z]|\"[A-Z]|\`)/\. /g;
     $line =~ s/\?(?=[A-Z]|\"[A-Z]|\`)/\? /g;
     $line =~ s/\! (?=[A-Z]|\"[A-Z]|\`)/\! /g;
     $line =~ s/\)(?=[A-Z]|\"[A-Z]|\`)/\) /g;

    $line =~ s/([A-Z]{1}\.)[ ]{2}(?=[A-Z])/\1 /;
# save the current line     
    print FH ($line);
# count words only, ignore separator lines
    chop ($line);
    if ($line =~ /\w/){
	@words = split(/[\t ]+/, $line);
	$wordcount += @words;
    }
}

print ("Total number of words: $wordcount\n");

close(FH);

# open "outfile" for reading

unless (open (INFILE,"outfile")) {
    die ("cannot open input file outfile\n");
}

# open $file_name (original source file)

unless (open (OUTFILE,">$file_name")) {
    die ("cannot open output file $file_name\n");
}

# copy "outfile" into original source file

$line = <INFILE>;
while ($line ne "") {
    print OUTFILE ($line);
    $line = <INFILE>;
}


###
### End of main body of script.
### Subroutines below.
###

